package ca.mcgill.acid.applications;

import ca.mcgill.acid.applications.Account;
import ca.mcgill.acid.interfaces.IMultiVersionLockBased;
import ca.mcgill.acid.interfaces.IShared;
import ca.mcgill.acid.utility.Update;
import ca.mcgill.acid.utility.Write;
 

public class CheckingAccount extends Account 
	implements IShared, IMultiVersionLockBased { 
	
	 
	public CheckingAccount(float _balance, int id)
	{
		balance = _balance;
		accountID = id;
	}  
	 
	
	@Write public void credit(float amount) 
	{
		balance = balance + amount;
	}
	

	@Update public float debit(float amount)
	{
		if(balance >= amount)
			balance = balance - amount;
		else
			amount = 0;
		
		return amount;
	}
	
}
