package ca.mcgill.acid.applications;

import ca.mcgill.acid.interfaces.ILockBased;
import ca.mcgill.acid.interfaces.IShared;
import ca.mcgill.acid.utility.Read;
import ca.mcgill.acid.utility.Update;
import ca.mcgill.acid.utility.Write;

public class CreditCard extends Account
implements ILockBased,IShared{  
	
	float interestRate;
	
	public CreditCard(float limit,int _id,  float _rate)
	{
		balance = limit;
		accountID = _id;
		interestRate = _rate;
	}	
	
	
	@Write public void credit(float credit)
	{
		balance = balance + credit;
	}

	@Update public float debit(float amount)
	{
		if(balance >= amount)
			balance = balance - amount;
		else
			amount = 0;
		
		return amount;
	}
	
	@Read public float getInterestRate()
	{
		return interestRate;
	}
	
	@Update public void updateInterestRate(float _rate)
	{
		interestRate = interestRate + _rate;
	}
	
}
