package ca.mcgill.acid.applications;


import ca.mcgill.acid.applications.Account;
import ca.mcgill.acid.interfaces.IAutoRecoverable;
import ca.mcgill.acid.interfaces.ITracked;
import ca.mcgill.acid.interfaces.IOptimisticBackwardValidation;
import ca.mcgill.acid.utility.Read;
import ca.mcgill.acid.utility.Update;
import ca.mcgill.acid.utility.Write;

 
public class SavingsAccount extends Account 
	implements IOptimisticBackwardValidation{
	 
	private float interestRate; 
	
	 public SavingsAccount(float _balance, int _id, float _rate)
	{
		balance = _balance;
		accountID = _id;
		interestRate = _rate;

	}  
	
	
	 @Write public void credit(float amount)
	{
		balance = balance + amount;
		
	}
	

	@Update public float debit(float amount)
	{
		if(balance >= amount)
			balance = balance - amount;
		else
			amount = 0;
		
		return amount;
	}
	
	@Update public void monthlyInterest()
	{
		balance = balance + (interestRate * balance);
	}
	
	@Read public float getInterestRate()
	{
		return interestRate;
	}
	
	@Update public void updateInterestRate(float _rate)
	{
		interestRate = interestRate + _rate;
	}
	

}
