/**
 * @author Ekwa Duala-Ekoko
 * @version 1.0
 *
 * Purpose: Declares the precedence of aspects that apply to the same jointpoint
 * 			 
 */
package ca.mcgill.acid.aspects;

public aspect Precedence {
	
	//Set the precedence for the after-constructor-execution jointpoints.
	//Desired execution order: Named, Versioned, MultiVersionLockBased
	declare precedence: MultiVersionLockBased, Versioned, Named; 

	//For lockBased concurrency control
	declare precedence: LockBased, Shared, AutoRecoverable, Versioned; 

	//For Multi-Version lockBased concurrency control
	declare precedence: MultiVersionLockBased, Shared,Versioned; 

	//For Optimistic backward validation concurrency control
	declare precedence: OptimisticBackwardValidation,AutoRecoverable, Versioned; 
}