 /**
 * @author Ekwa Duala-Ekoko
 * @version 1.0
 * Purpose: Enables serializability and deserializabolity of objects 
 * 			that implements the ISerializeable interface.
 */
package ca.mcgill.acid.aspects;

import ca.mcgill.acid.interfaces.INamed;
import ca.mcgill.acid.interfaces.IShared;
import java.io.Serializable;
import ca.mcgill.acid.interfaces.ISerializeable;
import ca.mcgill.acid.interfaces.ICopyable;
import java.io.FileOutputStream;
import java.io.ObjectOutputStream;
import java.io.FileInputStream;
import java.io.ObjectInputStream;
import java.io.IOException;

public aspect Serializeable {

	//Enables Serializability & Naming of classes that implements ISerializeable
	declare parents: ISerializeable implements Serializable,INamed,ICopyable; 

	// Serialize the "this" object to a file named this.getMyName()
	public void ISerializeable.serialize() { 
	 
		FileOutputStream file=null; 
		ObjectOutputStream out=null;
		try{
			 file = new FileOutputStream(this.getMyName());
			  out = new ObjectOutputStream(file);
			 out.writeObject(this);
			 
		}catch (IOException e ){
	          	e.printStackTrace();
        }finally{
		      try {
		            if (out != null) 
		               out.close();
		          
		            if (file != null) 
		               file.close();
		          
		          }
		         catch (IOException e ){
		        	 e.printStackTrace();
		         }
	    }
	} 
	
	// Deserialize the "this" object from the file named this.getMyName()
	public void ISerializeable.deserialize() { 	
        this.replaceState(this.createFromDeserialized());       
	} 
	
	// Create a new object from the serialized object
	public Object ISerializeable.createFromDeserialized() { 
		
		FileInputStream file = null;
		ObjectInputStream in = null;
		Object obj = null;
		try{
			 file = new FileInputStream(this.getMyName());
			 in = new ObjectInputStream(file);
			 obj = in.readObject();
			 
		}catch (IOException e ){
	          	e.printStackTrace();
        }catch (ClassNotFoundException e ){
	          	e.printStackTrace();
        }finally{
		      try {
		            if (in != null) 
		               in.close();
		          
		            if (file != null) 
		               file.close();
		          
		          }
		         catch (IOException e ){
		        	 e.printStackTrace();
		         }
	    }
        
        return obj;
	}
}
