package ca.mcgill.acid.tests;

import ca.mcgill.acid.applications.CheckingAccount;
import ca.mcgill.acid.aspects.AutoRecoverable;
import ca.mcgill.acid.aspects.MultiVersionLockBased;
import ca.mcgill.acid.aspects.Tracked;
import ca.mcgill.acid.aspects.Versioned;
import ca.mcgill.acid.utility.NoCreationTimeStampException;
import ca.mcgill.acid.utility.Signal;
import ca.mcgill.acid.utility.View;

public class MultiVersionWriteThread extends Thread{

	CheckingAccount account;
	
	public MultiVersionWriteThread(CheckingAccount acc) 
	{
		account = acc; 
	}
	
	public void run() { 
		
		//Begin AutoRecoverable zone
		View myView = Versioned.newView();
		AutoRecoverable.beginRecoverableZone(myView);
		
		//Begin Tracked zone 
		Tracked.beginTrackedZone();
		
		account.credit(100);
		
		Signal.commitMultiVersionLockBased();
		
	}
}
