package ca.mcgill.acid.tests;


import ca.mcgill.acid.applications.CheckingAccount;
import ca.mcgill.acid.aspects.AutoRecoverable;
import ca.mcgill.acid.aspects.MultiVersionLockBased;
import ca.mcgill.acid.aspects.Tracked;
import ca.mcgill.acid.aspects.Versioned;
import ca.mcgill.acid.interfaces.IVersioned;
import ca.mcgill.acid.utility.NoCreationTimeStampException;
import ca.mcgill.acid.utility.Signal;
import ca.mcgill.acid.utility.View;

public class MultiversionReadThread extends Thread{

	CheckingAccount account;
	CheckingAccount account1;
	
	public MultiversionReadThread(CheckingAccount acc, CheckingAccount acc1) 
	{
		account = acc; 
		account1 = acc1; 
	}
	
	public void run() { 
		
		try {
			Thread.sleep(90);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		//set transaction to Read-only
		int startTime = MultiVersionLockBased.startReadOnlyTransaction();
		System.out.println("[Begin Read-Only @ TimeStamp<"+startTime+"> For <" + this.getName()+">");
		
		//Begin AutoRecoverable zone
		View myView = Versioned.newView();
		AutoRecoverable.beginRecoverableZone(myView);
		
		//Begin Tracked zone 
		Tracked.beginTrackedZone(); 
		
		System.out.println("	Balance @Write : " + account.getBalance() +
				"		For_Object <" + ((IVersioned)account).getMyName()+">");
		
		System.out.println("	Balance @Update: " + account1.getBalance()+
				"		For_Object <" + ((IVersioned)account1).getMyName()+">");
		
		System.out.println( "[End Read-Only For <"+ this.getName() + ">" );
		
	}
}
