package ca.mcgill.acid.tests;

import ca.mcgill.acid.applications.SavingsAccount;
import ca.mcgill.acid.aspects.AutoRecoverable;
import ca.mcgill.acid.aspects.Tracked;
import ca.mcgill.acid.aspects.Versioned;
import ca.mcgill.acid.utility.Signal;
import ca.mcgill.acid.utility.View;

public class OptimisticBackwardReadThread extends Thread {

SavingsAccount account;
	
	public OptimisticBackwardReadThread(SavingsAccount acc) 
	{
		account = acc; 

	} 
	
	public void run() { 
		
		try {
			Thread.sleep(50);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		System.out.println("[Begin Read-Only For <" + this.getName()+">");
		//Begin AutoRecoverable zone
		View myView = Versioned.newView();
		AutoRecoverable.beginRecoverableZone(myView);
		
		//Begin Tracked zone 
		Tracked.beginTrackedZone();
		
		System.out.println("		Balance: " + account.getBalance());
		System.out.println("[End Read-Only For <" + this.getName()+">");
	}
}
