package ca.mcgill.acid.tests;

import ca.mcgill.acid.applications.SavingsAccount;
import ca.mcgill.acid.aspects.AutoRecoverable;
import ca.mcgill.acid.aspects.Tracked;
import ca.mcgill.acid.aspects.Versioned;
import ca.mcgill.acid.utility.Signal;
import ca.mcgill.acid.utility.View;

public class OptimisticBackwardUpdateThread extends Thread{

	SavingsAccount account;
	
	public OptimisticBackwardUpdateThread(SavingsAccount acc) 
	{
		account = acc; 

	} 
	
	public void run() { 
		
		System.out.println("[Begin Update-Transaction For <" + this.getName()+">");
		//Begin AutoRecoverable zone
		View myView = Versioned.newView();
		AutoRecoverable.beginRecoverableZone(myView);
		
		//Begin Tracked zone 
		Tracked.beginTrackedZone();
		
		account.debit(100);
		
		Signal.commitOptimisticBackwardValidation();
		System.out.println("[End Update-Transaction For <" + this.getName()+">");
	}
}
