package ca.mcgill.acid.tests;
  
import ca.mcgill.acid.applications.CheckingAccount;
import ca.mcgill.acid.applications.CreditCard;
import ca.mcgill.acid.applications.SavingsAccount;

public class RunTests  {
	
   public static void main(String[] args) throws Exception {
	  
	    lockBased();
	   //multiVersionLockBased();
	   //optimisticBackwardValidation();
   }
   
   private static void lockBased()
   {   
	   //---------------------------- LOCKBASED ----------------------------//
	  CreditCard cc3 = new CreditCard(1000, 3, 18); //Limit(1000), ID(3), Interest(18%)
	  CreditCard cc4 = new CreditCard(2000, 4, 20); //Limit(2000), ID(4), Interest(20%)
	  
	  LockBasedReadThread  t4 = new LockBasedReadThread (cc3);
	  LockBasedUpdateThread  t5 = new LockBasedUpdateThread(cc3,cc4);
	  
	  t4.setName("LockBasedRead");
	  t5.setName("LockBasedUpdate");
	   
	   t4.start();
	   t5.start();
   }
   
   private static void multiVersionLockBased()
   {
	   //---------------------------- MULTIVERSION LOCKBASED ----------------------------//
		  CheckingAccount cc1 = new CheckingAccount(1000,1); //Balance(1000), ID(1)
		  CheckingAccount cc2 = new CheckingAccount(2000,2); //Balance(1000), ID(2)
		  
		  MultiVersionWriteThread  t1 = new MultiVersionWriteThread(cc1);
		  MultiVersionUpdateThread  t2 = new MultiVersionUpdateThread(cc2);
		  MultiversionReadThread  t3 = new MultiversionReadThread(cc1,cc2);
		   
		  
		  t1.setName("MultiVWriteThread");
		  t2.setName("MultiVUpdateThread");
		  t3.setName("MultiVReadThread");
		   
		   t1.start();
		   t2.start();
		   t3.start();
   }
   
   private static void optimisticBackwardValidation()
   {
	   //---------------------------- OPTIMISTIC BACKWARD VALIDATION ----------------------------//
		  SavingsAccount cc1 = new SavingsAccount (1000,1,3); //Balance(1000), ID(1)
		  
		  OptimisticBackwardWriteThread  t1 = new OptimisticBackwardWriteThread(cc1);
		  OptimisticBackwardReadThread t2 = new OptimisticBackwardReadThread(cc1);
		  OptimisticBackwardUpdateThread  t3 = new OptimisticBackwardUpdateThread(cc1);
		  
		  t1.setName("OptimisticBackwardWrite");
		  t2.setName("OptimisticBackwardRead");
		  t3.setName("OptimisticBackwardUpdate");
		   
		  t1.start();
		  t2.start();
		  t3.start();
   }
   
}
