package ca.mcgill.acid.utility;

/**
 * Provides exclusive access to a shared resource.
 * 
 */

import java.io.Serializable;

public class Semaphore implements Serializable {
	
	transient private  boolean inUse;
	
	public Semaphore ()
	{
		inUse = false;
	}
	

	/**
	 * Acquire lock if not in use. Otherwise, wait till lock is available
	 * 
	 */
	public synchronized void P()
	{ 
		while(inUse == true) 
		{
			try {
				wait();
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
		inUse = true; 
		 
	}
	
	/**
	 * Release lock and wake up sleep threads
	 * 
	 */
	public synchronized void V() throws SemaphoreException
	{
		if(inUse == false)
			throw new SemaphoreException("\n	The P() operation must be called before the V() operation");
		inUse = false;
		notifyAll();
	}

}
